/**
 */
package de.hftstuttgart.buildingphysics;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage
 * @generated
 */
public interface BuildingPhysicsFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	BuildingPhysicsFactory eINSTANCE = de.hftstuttgart.buildingphysics.impl.BuildingPhysicsFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Catalog</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Catalog</em>'.
	 * @generated
	 */
	BuildingPhysicsCatalog createBuildingPhysicsCatalog();

	/**
	 * Returns a new object of class '<em>Window Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Window Type</em>'.
	 * @generated
	 */
	WindowType createWindowType();

	/**
	 * Returns a new object of class '<em>Window Catalog</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Window Catalog</em>'.
	 * @generated
	 */
	WindowCatalog createWindowCatalog();

	/**
	 * Returns a new object of class '<em>Material Catalog</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Material Catalog</em>'.
	 * @generated
	 */
	MaterialCatalog createMaterialCatalog();

	/**
	 * Returns a new object of class '<em>Material Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Material Category</em>'.
	 * @generated
	 */
	MaterialCategory createMaterialCategory();

	/**
	 * Returns a new object of class '<em>Material</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Material</em>'.
	 * @generated
	 */
	Material createMaterial();

	/**
	 * Returns a new object of class '<em>Construction Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Construction Category</em>'.
	 * @generated
	 */
	ConstructionCategory createConstructionCategory();

	/**
	 * Returns a new object of class '<em>Mounting</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Mounting</em>'.
	 * @generated
	 */
	Mounting createMounting();

	/**
	 * Returns a new object of class '<em>Layer</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Layer</em>'.
	 * @generated
	 */
	Layer createLayer();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	BuildingPhysicsPackage getBuildingPhysicsPackage();

} //BuildingPhysicsFactory
