/**
 */
package de.hftstuttgart.buildingphysics;

import de.hftstuttgart.cityunits.model.NullableQuantity;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Material</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.buildingphysics.Material#getMaterialId <em>Material Id</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.Material#getName <em>Name</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.Material#getDensity <em>Density</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.Material#getHeatCapacity <em>Heat Capacity</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.Material#getConductivity <em>Conductivity</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.Material#getEmbodiedEnergy <em>Embodied Energy</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.Material#getEmbodiedCarbon <em>Embodied Carbon</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.Material#getConstructionDescription <em>Construction Description</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.Material#getDisposalEnergy <em>Disposal Energy</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.Material#getDisposalCarbon <em>Disposal Carbon</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.Material#getDisposalDescription <em>Disposal Description</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.Material#getCategory <em>Category</em>}</li>
 * </ul>
 *
 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getMaterial()
 * @model
 * @generated
 */
public interface Material extends EObject {
	/**
	 * Returns the value of the '<em><b>Material Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Material Id</em>' attribute.
	 * @see #setMaterialId(String)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getMaterial_MaterialId()
	 * @model id="true" required="true"
	 * @generated
	 */
	String getMaterialId();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.Material#getMaterialId <em>Material Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Material Id</em>' attribute.
	 * @see #getMaterialId()
	 * @generated
	 */
	void setMaterialId(String value);

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getMaterial_Name()
	 * @model required="true"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.Material#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Density</b></em>' attribute.
	 * The default value is <code>"kg/m\u00b3"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Density</em>' attribute.
	 * @see #setDensity(NullableQuantity)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getMaterial_Density()
	 * @model default="kg/m\u00b3" dataType="de.hftstuttgart.cityunits.model.quantities.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getDensity();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.Material#getDensity <em>Density</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Density</em>' attribute.
	 * @see #getDensity()
	 * @generated
	 */
	void setDensity(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Heat Capacity</b></em>' attribute.
	 * The default value is <code>"J/K"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Heat Capacity</em>' attribute.
	 * @see #setHeatCapacity(NullableQuantity)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getMaterial_HeatCapacity()
	 * @model default="J/K" dataType="de.hftstuttgart.cityunits.model.quantities.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getHeatCapacity();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.Material#getHeatCapacity <em>Heat Capacity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Heat Capacity</em>' attribute.
	 * @see #getHeatCapacity()
	 * @generated
	 */
	void setHeatCapacity(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Conductivity</b></em>' attribute.
	 * The default value is <code>"W/(m*K)"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Conductivity</em>' attribute.
	 * @see #setConductivity(NullableQuantity)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getMaterial_Conductivity()
	 * @model default="W/(m*K)" dataType="de.hftstuttgart.cityunits.model.quantities.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getConductivity();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.Material#getConductivity <em>Conductivity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Conductivity</em>' attribute.
	 * @see #getConductivity()
	 * @generated
	 */
	void setConductivity(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Embodied Energy</b></em>' attribute.
	 * The default value is <code>"kW*h/kg"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Embodied Energy</em>' attribute.
	 * @see #setEmbodiedEnergy(NullableQuantity)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getMaterial_EmbodiedEnergy()
	 * @model default="kW*h/kg" dataType="de.hftstuttgart.cityunits.model.quantities.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getEmbodiedEnergy();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.Material#getEmbodiedEnergy <em>Embodied Energy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Embodied Energy</em>' attribute.
	 * @see #getEmbodiedEnergy()
	 * @generated
	 */
	void setEmbodiedEnergy(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Embodied Carbon</b></em>' attribute.
	 * The default value is <code>"kg"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Embodied Carbon</em>' attribute.
	 * @see #setEmbodiedCarbon(NullableQuantity)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getMaterial_EmbodiedCarbon()
	 * @model default="kg" dataType="de.hftstuttgart.cityunits.model.quantities.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getEmbodiedCarbon();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.Material#getEmbodiedCarbon <em>Embodied Carbon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Embodied Carbon</em>' attribute.
	 * @see #getEmbodiedCarbon()
	 * @generated
	 */
	void setEmbodiedCarbon(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Construction Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Construction Description</em>' attribute.
	 * @see #setConstructionDescription(String)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getMaterial_ConstructionDescription()
	 * @model required="true"
	 * @generated
	 */
	String getConstructionDescription();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.Material#getConstructionDescription <em>Construction Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Construction Description</em>' attribute.
	 * @see #getConstructionDescription()
	 * @generated
	 */
	void setConstructionDescription(String value);

	/**
	 * Returns the value of the '<em><b>Disposal Energy</b></em>' attribute.
	 * The default value is <code>"kW*h/kg"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Disposal Energy</em>' attribute.
	 * @see #setDisposalEnergy(NullableQuantity)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getMaterial_DisposalEnergy()
	 * @model default="kW*h/kg" dataType="de.hftstuttgart.cityunits.model.quantities.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getDisposalEnergy();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.Material#getDisposalEnergy <em>Disposal Energy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Disposal Energy</em>' attribute.
	 * @see #getDisposalEnergy()
	 * @generated
	 */
	void setDisposalEnergy(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Disposal Carbon</b></em>' attribute.
	 * The default value is <code>"kg"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Disposal Carbon</em>' attribute.
	 * @see #setDisposalCarbon(NullableQuantity)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getMaterial_DisposalCarbon()
	 * @model default="kg" dataType="de.hftstuttgart.cityunits.model.quantities.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getDisposalCarbon();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.Material#getDisposalCarbon <em>Disposal Carbon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Disposal Carbon</em>' attribute.
	 * @see #getDisposalCarbon()
	 * @generated
	 */
	void setDisposalCarbon(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Disposal Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Disposal Description</em>' attribute.
	 * @see #setDisposalDescription(String)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getMaterial_DisposalDescription()
	 * @model required="true"
	 * @generated
	 */
	String getDisposalDescription();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.Material#getDisposalDescription <em>Disposal Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Disposal Description</em>' attribute.
	 * @see #getDisposalDescription()
	 * @generated
	 */
	void setDisposalDescription(String value);

	/**
	 * Returns the value of the '<em><b>Category</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link de.hftstuttgart.buildingphysics.MaterialCategory#getMaterials <em>Materials</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Category</em>' container reference.
	 * @see #setCategory(MaterialCategory)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getMaterial_Category()
	 * @see de.hftstuttgart.buildingphysics.MaterialCategory#getMaterials
	 * @model opposite="materials" required="true" transient="false" ordered="false"
	 * @generated
	 */
	MaterialCategory getCategory();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.Material#getCategory <em>Category</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Category</em>' container reference.
	 * @see #getCategory()
	 * @generated
	 */
	void setCategory(MaterialCategory value);

} // Material
