/**
 */
package de.hftstuttgart.buildingphysics;

import de.hftstuttgart.cityunits.model.NullableQuantity;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Window Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.buildingphysics.WindowType#getWindowTypeId <em>Window Type Id</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.WindowType#getName <em>Name</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.WindowType#getUValue <em>UValue</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.WindowType#getGValue <em>GValue</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.WindowType#getGlazingNumber <em>Glazing Number</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.WindowType#getFrameRatio <em>Frame Ratio</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.WindowType#getEmbodiedEnergy <em>Embodied Energy</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.WindowType#getEmbodiedCarbon <em>Embodied Carbon</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.WindowType#getConstructionDescription <em>Construction Description</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.WindowType#getDisposalEnergy <em>Disposal Energy</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.WindowType#getDisposalCarbon <em>Disposal Carbon</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.WindowType#getDisposalDescription <em>Disposal Description</em>}</li>
 * </ul>
 *
 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType()
 * @model
 * @generated
 */
public interface WindowType extends EObject {
	/**
	 * Returns the value of the '<em><b>Window Type Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Window Type Id</em>' attribute.
	 * @see #setWindowTypeId(String)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType_WindowTypeId()
	 * @model id="true" required="true"
	 * @generated
	 */
	String getWindowTypeId();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.WindowType#getWindowTypeId <em>Window Type Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Window Type Id</em>' attribute.
	 * @see #getWindowTypeId()
	 * @generated
	 */
	void setWindowTypeId(String value);

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType_Name()
	 * @model required="true"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.WindowType#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>UValue</b></em>' attribute.
	 * The default value is <code>"W/(m\u00b2*K)"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>UValue</em>' attribute.
	 * @see #setUValue(NullableQuantity)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType_UValue()
	 * @model default="W/(m\u00b2*K)" dataType="de.hftstuttgart.cityunits.model.quantities.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getUValue();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.WindowType#getUValue <em>UValue</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>UValue</em>' attribute.
	 * @see #getUValue()
	 * @generated
	 */
	void setUValue(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>GValue</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * coefficient between 0.0 (window with no solar energy transmittance) and 1.0 (full transmittance of all solar radiation)
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>GValue</em>' attribute.
	 * @see #setGValue(double)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType_GValue()
	 * @model required="true"
	 * @generated
	 */
	double getGValue();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.WindowType#getGValue <em>GValue</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>GValue</em>' attribute.
	 * @see #getGValue()
	 * @generated
	 */
	void setGValue(double value);

	/**
	 * Returns the value of the '<em><b>Glazing Number</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Glazing Number</em>' attribute.
	 * @see #setGlazingNumber(int)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType_GlazingNumber()
	 * @model default="1" required="true"
	 * @generated
	 */
	int getGlazingNumber();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.WindowType#getGlazingNumber <em>Glazing Number</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Glazing Number</em>' attribute.
	 * @see #getGlazingNumber()
	 * @generated
	 */
	void setGlazingNumber(int value);

	/**
	 * Returns the value of the '<em><b>Frame Ratio</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * fraction between 0.0 and 1.0
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Frame Ratio</em>' attribute.
	 * @see #setFrameRatio(double)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType_FrameRatio()
	 * @model required="true"
	 * @generated
	 */
	double getFrameRatio();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.WindowType#getFrameRatio <em>Frame Ratio</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Frame Ratio</em>' attribute.
	 * @see #getFrameRatio()
	 * @generated
	 */
	void setFrameRatio(double value);

	/**
	 * Returns the value of the '<em><b>Embodied Energy</b></em>' attribute.
	 * The default value is <code>"kW*h/m\u00b2"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Embodied Energy</em>' attribute.
	 * @see #setEmbodiedEnergy(NullableQuantity)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType_EmbodiedEnergy()
	 * @model default="kW*h/m\u00b2" dataType="de.hftstuttgart.cityunits.model.quantities.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getEmbodiedEnergy();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.WindowType#getEmbodiedEnergy <em>Embodied Energy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Embodied Energy</em>' attribute.
	 * @see #getEmbodiedEnergy()
	 * @generated
	 */
	void setEmbodiedEnergy(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Embodied Carbon</b></em>' attribute.
	 * The default value is <code>"kg"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Embodied Carbon</em>' attribute.
	 * @see #setEmbodiedCarbon(NullableQuantity)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType_EmbodiedCarbon()
	 * @model default="kg" dataType="de.hftstuttgart.cityunits.model.quantities.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getEmbodiedCarbon();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.WindowType#getEmbodiedCarbon <em>Embodied Carbon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Embodied Carbon</em>' attribute.
	 * @see #getEmbodiedCarbon()
	 * @generated
	 */
	void setEmbodiedCarbon(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Construction Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Construction Description</em>' attribute.
	 * @see #setConstructionDescription(String)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType_ConstructionDescription()
	 * @model required="true"
	 * @generated
	 */
	String getConstructionDescription();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.WindowType#getConstructionDescription <em>Construction Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Construction Description</em>' attribute.
	 * @see #getConstructionDescription()
	 * @generated
	 */
	void setConstructionDescription(String value);

	/**
	 * Returns the value of the '<em><b>Disposal Energy</b></em>' attribute.
	 * The default value is <code>"kW*h/m\u00b2"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Disposal Energy</em>' attribute.
	 * @see #setDisposalEnergy(NullableQuantity)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType_DisposalEnergy()
	 * @model default="kW*h/m\u00b2" dataType="de.hftstuttgart.cityunits.model.quantities.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getDisposalEnergy();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.WindowType#getDisposalEnergy <em>Disposal Energy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Disposal Energy</em>' attribute.
	 * @see #getDisposalEnergy()
	 * @generated
	 */
	void setDisposalEnergy(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Disposal Carbon</b></em>' attribute.
	 * The default value is <code>"kg"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Disposal Carbon</em>' attribute.
	 * @see #setDisposalCarbon(NullableQuantity)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType_DisposalCarbon()
	 * @model default="kg" dataType="de.hftstuttgart.cityunits.model.quantities.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getDisposalCarbon();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.WindowType#getDisposalCarbon <em>Disposal Carbon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Disposal Carbon</em>' attribute.
	 * @see #getDisposalCarbon()
	 * @generated
	 */
	void setDisposalCarbon(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Disposal Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Disposal Description</em>' attribute.
	 * @see #setDisposalDescription(String)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType_DisposalDescription()
	 * @model required="true"
	 * @generated
	 */
	String getDisposalDescription();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.WindowType#getDisposalDescription <em>Disposal Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Disposal Description</em>' attribute.
	 * @see #getDisposalDescription()
	 * @generated
	 */
	void setDisposalDescription(String value);

} // WindowType
