/**
 */
package de.hftstuttgart.buildingphysics.impl;

import de.hftstuttgart.buildingphysics.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class BuildingPhysicsFactoryImpl extends EFactoryImpl implements BuildingPhysicsFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static BuildingPhysicsFactory init() {
		try {
			BuildingPhysicsFactory theBuildingPhysicsFactory = (BuildingPhysicsFactory) EPackage.Registry.INSTANCE
					.getEFactory(BuildingPhysicsPackage.eNS_URI);
			if (theBuildingPhysicsFactory != null) {
				return theBuildingPhysicsFactory;
			}
		} catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new BuildingPhysicsFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BuildingPhysicsFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
		case BuildingPhysicsPackage.BUILDING_PHYSICS_CATALOG:
			return createBuildingPhysicsCatalog();
		case BuildingPhysicsPackage.WINDOW_TYPE:
			return createWindowType();
		case BuildingPhysicsPackage.WINDOW_CATALOG:
			return createWindowCatalog();
		case BuildingPhysicsPackage.MATERIAL_CATALOG:
			return createMaterialCatalog();
		case BuildingPhysicsPackage.MATERIAL_CATEGORY:
			return createMaterialCategory();
		case BuildingPhysicsPackage.MATERIAL:
			return createMaterial();
		case BuildingPhysicsPackage.CONSTRUCTION_CATEGORY:
			return createConstructionCategory();
		case BuildingPhysicsPackage.MOUNTING:
			return createMounting();
		case BuildingPhysicsPackage.LAYER:
			return createLayer();
		default:
			throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public BuildingPhysicsCatalog createBuildingPhysicsCatalog() {
		BuildingPhysicsCatalogImpl buildingPhysicsCatalog = new BuildingPhysicsCatalogImpl();
		return buildingPhysicsCatalog;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public WindowType createWindowType() {
		WindowTypeImpl windowType = new WindowTypeImpl();
		return windowType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public WindowCatalog createWindowCatalog() {
		WindowCatalogImpl windowCatalog = new WindowCatalogImpl();
		return windowCatalog;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MaterialCatalog createMaterialCatalog() {
		MaterialCatalogImpl materialCatalog = new MaterialCatalogImpl();
		return materialCatalog;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MaterialCategory createMaterialCategory() {
		MaterialCategoryImpl materialCategory = new MaterialCategoryImpl();
		return materialCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Material createMaterial() {
		MaterialImpl material = new MaterialImpl();
		return material;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ConstructionCategory createConstructionCategory() {
		ConstructionCategoryImpl constructionCategory = new ConstructionCategoryImpl();
		return constructionCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Mounting createMounting() {
		MountingImpl mounting = new MountingImpl();
		return mounting;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Layer createLayer() {
		LayerImpl layer = new LayerImpl();
		return layer;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public BuildingPhysicsPackage getBuildingPhysicsPackage() {
		return (BuildingPhysicsPackage) getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static BuildingPhysicsPackage getPackage() {
		return BuildingPhysicsPackage.eINSTANCE;
	}

} //BuildingPhysicsFactoryImpl
