/**
 */
package de.hftstuttgart.buildingphysics.impl;

import de.hftstuttgart.buildingphysics.BuildingPhysicsPackage;
import de.hftstuttgart.buildingphysics.ConstructionCategory;
import de.hftstuttgart.buildingphysics.MaterialCatalog;
import de.hftstuttgart.buildingphysics.MaterialCategory;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Material Catalog</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.buildingphysics.impl.MaterialCatalogImpl#getMaterialCategories <em>Material Categories</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.impl.MaterialCatalogImpl#getConstructionCategories <em>Construction Categories</em>}</li>
 * </ul>
 *
 * @generated
 */
public class MaterialCatalogImpl extends CatalogImpl implements MaterialCatalog {
	/**
	 * The cached value of the '{@link #getMaterialCategories() <em>Material Categories</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaterialCategories()
	 * @generated
	 * @ordered
	 */
	protected EList<MaterialCategory> materialCategories;

	/**
	 * The cached value of the '{@link #getConstructionCategories() <em>Construction Categories</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConstructionCategories()
	 * @generated
	 * @ordered
	 */
	protected EList<ConstructionCategory> constructionCategories;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MaterialCatalogImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return BuildingPhysicsPackage.Literals.MATERIAL_CATALOG;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MaterialCategory> getMaterialCategories() {
		if (materialCategories == null) {
			materialCategories = new EObjectContainmentEList<MaterialCategory>(MaterialCategory.class, this,
					BuildingPhysicsPackage.MATERIAL_CATALOG__MATERIAL_CATEGORIES);
		}
		return materialCategories;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<ConstructionCategory> getConstructionCategories() {
		if (constructionCategories == null) {
			constructionCategories = new EObjectContainmentEList<ConstructionCategory>(ConstructionCategory.class, this,
					BuildingPhysicsPackage.MATERIAL_CATALOG__CONSTRUCTION_CATEGORIES);
		}
		return constructionCategories;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case BuildingPhysicsPackage.MATERIAL_CATALOG__MATERIAL_CATEGORIES:
			return ((InternalEList<?>) getMaterialCategories()).basicRemove(otherEnd, msgs);
		case BuildingPhysicsPackage.MATERIAL_CATALOG__CONSTRUCTION_CATEGORIES:
			return ((InternalEList<?>) getConstructionCategories()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case BuildingPhysicsPackage.MATERIAL_CATALOG__MATERIAL_CATEGORIES:
			return getMaterialCategories();
		case BuildingPhysicsPackage.MATERIAL_CATALOG__CONSTRUCTION_CATEGORIES:
			return getConstructionCategories();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case BuildingPhysicsPackage.MATERIAL_CATALOG__MATERIAL_CATEGORIES:
			getMaterialCategories().clear();
			getMaterialCategories().addAll((Collection<? extends MaterialCategory>) newValue);
			return;
		case BuildingPhysicsPackage.MATERIAL_CATALOG__CONSTRUCTION_CATEGORIES:
			getConstructionCategories().clear();
			getConstructionCategories().addAll((Collection<? extends ConstructionCategory>) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case BuildingPhysicsPackage.MATERIAL_CATALOG__MATERIAL_CATEGORIES:
			getMaterialCategories().clear();
			return;
		case BuildingPhysicsPackage.MATERIAL_CATALOG__CONSTRUCTION_CATEGORIES:
			getConstructionCategories().clear();
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case BuildingPhysicsPackage.MATERIAL_CATALOG__MATERIAL_CATEGORIES:
			return materialCategories != null && !materialCategories.isEmpty();
		case BuildingPhysicsPackage.MATERIAL_CATALOG__CONSTRUCTION_CATEGORIES:
			return constructionCategories != null && !constructionCategories.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //MaterialCatalogImpl
