/**
 */
package de.hftstuttgart.buildingphysics.impl;

import de.hftstuttgart.buildingphysics.BuildingPhysicsPackage;
import de.hftstuttgart.buildingphysics.WindowType;

import de.hftstuttgart.cityunits.model.NullableQuantity;

import de.hftstuttgart.cityunits.model.quantities.QuantitiesFactory;
import de.hftstuttgart.cityunits.model.quantities.QuantitiesPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Window Type</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.buildingphysics.impl.WindowTypeImpl#getWindowTypeId <em>Window Type Id</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.impl.WindowTypeImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.impl.WindowTypeImpl#getUValue <em>UValue</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.impl.WindowTypeImpl#getGValue <em>GValue</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.impl.WindowTypeImpl#getGlazingNumber <em>Glazing Number</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.impl.WindowTypeImpl#getFrameRatio <em>Frame Ratio</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.impl.WindowTypeImpl#getEmbodiedEnergy <em>Embodied Energy</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.impl.WindowTypeImpl#getEmbodiedCarbon <em>Embodied Carbon</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.impl.WindowTypeImpl#getConstructionDescription <em>Construction Description</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.impl.WindowTypeImpl#getDisposalEnergy <em>Disposal Energy</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.impl.WindowTypeImpl#getDisposalCarbon <em>Disposal Carbon</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.impl.WindowTypeImpl#getDisposalDescription <em>Disposal Description</em>}</li>
 * </ul>
 *
 * @generated
 */
public class WindowTypeImpl extends MinimalEObjectImpl.Container implements WindowType {
	/**
	 * The default value of the '{@link #getWindowTypeId() <em>Window Type Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getWindowTypeId()
	 * @generated
	 * @ordered
	 */
	protected static final String WINDOW_TYPE_ID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getWindowTypeId() <em>Window Type Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getWindowTypeId()
	 * @generated
	 * @ordered
	 */
	protected String windowTypeId = WINDOW_TYPE_ID_EDEFAULT;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getUValue() <em>UValue</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUValue()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity UVALUE_EDEFAULT = (NullableQuantity) QuantitiesFactory.eINSTANCE
			.createFromString(QuantitiesPackage.eINSTANCE.getQuantityDouble(), "W/(m\u00b2*K)");

	/**
	 * The cached value of the '{@link #getUValue() <em>UValue</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUValue()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity uValue = UVALUE_EDEFAULT;

	/**
	 * The default value of the '{@link #getGValue() <em>GValue</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGValue()
	 * @generated
	 * @ordered
	 */
	protected static final double GVALUE_EDEFAULT = 0.0;

	/**
	 * The cached value of the '{@link #getGValue() <em>GValue</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGValue()
	 * @generated
	 * @ordered
	 */
	protected double gValue = GVALUE_EDEFAULT;

	/**
	 * The default value of the '{@link #getGlazingNumber() <em>Glazing Number</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGlazingNumber()
	 * @generated
	 * @ordered
	 */
	protected static final int GLAZING_NUMBER_EDEFAULT = 1;

	/**
	 * The cached value of the '{@link #getGlazingNumber() <em>Glazing Number</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGlazingNumber()
	 * @generated
	 * @ordered
	 */
	protected int glazingNumber = GLAZING_NUMBER_EDEFAULT;

	/**
	 * The default value of the '{@link #getFrameRatio() <em>Frame Ratio</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFrameRatio()
	 * @generated
	 * @ordered
	 */
	protected static final double FRAME_RATIO_EDEFAULT = 0.0;

	/**
	 * The cached value of the '{@link #getFrameRatio() <em>Frame Ratio</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFrameRatio()
	 * @generated
	 * @ordered
	 */
	protected double frameRatio = FRAME_RATIO_EDEFAULT;

	/**
	 * The default value of the '{@link #getEmbodiedEnergy() <em>Embodied Energy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEmbodiedEnergy()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity EMBODIED_ENERGY_EDEFAULT = (NullableQuantity) QuantitiesFactory.eINSTANCE
			.createFromString(QuantitiesPackage.eINSTANCE.getQuantityDouble(), "kW*h/m\u00b2");

	/**
	 * The cached value of the '{@link #getEmbodiedEnergy() <em>Embodied Energy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEmbodiedEnergy()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity embodiedEnergy = EMBODIED_ENERGY_EDEFAULT;

	/**
	 * The default value of the '{@link #getEmbodiedCarbon() <em>Embodied Carbon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEmbodiedCarbon()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity EMBODIED_CARBON_EDEFAULT = (NullableQuantity) QuantitiesFactory.eINSTANCE
			.createFromString(QuantitiesPackage.eINSTANCE.getQuantityDouble(), "kg");

	/**
	 * The cached value of the '{@link #getEmbodiedCarbon() <em>Embodied Carbon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEmbodiedCarbon()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity embodiedCarbon = EMBODIED_CARBON_EDEFAULT;

	/**
	 * The default value of the '{@link #getConstructionDescription() <em>Construction Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConstructionDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String CONSTRUCTION_DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getConstructionDescription() <em>Construction Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConstructionDescription()
	 * @generated
	 * @ordered
	 */
	protected String constructionDescription = CONSTRUCTION_DESCRIPTION_EDEFAULT;

	/**
	 * The default value of the '{@link #getDisposalEnergy() <em>Disposal Energy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisposalEnergy()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity DISPOSAL_ENERGY_EDEFAULT = (NullableQuantity) QuantitiesFactory.eINSTANCE
			.createFromString(QuantitiesPackage.eINSTANCE.getQuantityDouble(), "kW*h/m\u00b2");

	/**
	 * The cached value of the '{@link #getDisposalEnergy() <em>Disposal Energy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisposalEnergy()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity disposalEnergy = DISPOSAL_ENERGY_EDEFAULT;

	/**
	 * The default value of the '{@link #getDisposalCarbon() <em>Disposal Carbon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisposalCarbon()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity DISPOSAL_CARBON_EDEFAULT = (NullableQuantity) QuantitiesFactory.eINSTANCE
			.createFromString(QuantitiesPackage.eINSTANCE.getQuantityDouble(), "kg");

	/**
	 * The cached value of the '{@link #getDisposalCarbon() <em>Disposal Carbon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisposalCarbon()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity disposalCarbon = DISPOSAL_CARBON_EDEFAULT;

	/**
	 * The default value of the '{@link #getDisposalDescription() <em>Disposal Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisposalDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DISPOSAL_DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDisposalDescription() <em>Disposal Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisposalDescription()
	 * @generated
	 * @ordered
	 */
	protected String disposalDescription = DISPOSAL_DESCRIPTION_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected WindowTypeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return BuildingPhysicsPackage.Literals.WINDOW_TYPE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getWindowTypeId() {
		return windowTypeId;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setWindowTypeId(String newWindowTypeId) {
		String oldWindowTypeId = windowTypeId;
		windowTypeId = newWindowTypeId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, BuildingPhysicsPackage.WINDOW_TYPE__WINDOW_TYPE_ID,
					oldWindowTypeId, windowTypeId));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, BuildingPhysicsPackage.WINDOW_TYPE__NAME, oldName,
					name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getUValue() {
		return uValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setUValue(NullableQuantity newUValue) {
		NullableQuantity oldUValue = uValue;
		uValue = newUValue;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, BuildingPhysicsPackage.WINDOW_TYPE__UVALUE, oldUValue,
					uValue));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getGValue() {
		return gValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setGValue(double newGValue) {
		double oldGValue = gValue;
		gValue = newGValue;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, BuildingPhysicsPackage.WINDOW_TYPE__GVALUE, oldGValue,
					gValue));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int getGlazingNumber() {
		return glazingNumber;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setGlazingNumber(int newGlazingNumber) {
		int oldGlazingNumber = glazingNumber;
		glazingNumber = newGlazingNumber;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, BuildingPhysicsPackage.WINDOW_TYPE__GLAZING_NUMBER,
					oldGlazingNumber, glazingNumber));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getFrameRatio() {
		return frameRatio;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setFrameRatio(double newFrameRatio) {
		double oldFrameRatio = frameRatio;
		frameRatio = newFrameRatio;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, BuildingPhysicsPackage.WINDOW_TYPE__FRAME_RATIO,
					oldFrameRatio, frameRatio));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getEmbodiedEnergy() {
		return embodiedEnergy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setEmbodiedEnergy(NullableQuantity newEmbodiedEnergy) {
		NullableQuantity oldEmbodiedEnergy = embodiedEnergy;
		embodiedEnergy = newEmbodiedEnergy;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, BuildingPhysicsPackage.WINDOW_TYPE__EMBODIED_ENERGY,
					oldEmbodiedEnergy, embodiedEnergy));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getEmbodiedCarbon() {
		return embodiedCarbon;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setEmbodiedCarbon(NullableQuantity newEmbodiedCarbon) {
		NullableQuantity oldEmbodiedCarbon = embodiedCarbon;
		embodiedCarbon = newEmbodiedCarbon;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, BuildingPhysicsPackage.WINDOW_TYPE__EMBODIED_CARBON,
					oldEmbodiedCarbon, embodiedCarbon));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getConstructionDescription() {
		return constructionDescription;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setConstructionDescription(String newConstructionDescription) {
		String oldConstructionDescription = constructionDescription;
		constructionDescription = newConstructionDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					BuildingPhysicsPackage.WINDOW_TYPE__CONSTRUCTION_DESCRIPTION, oldConstructionDescription,
					constructionDescription));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getDisposalEnergy() {
		return disposalEnergy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setDisposalEnergy(NullableQuantity newDisposalEnergy) {
		NullableQuantity oldDisposalEnergy = disposalEnergy;
		disposalEnergy = newDisposalEnergy;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, BuildingPhysicsPackage.WINDOW_TYPE__DISPOSAL_ENERGY,
					oldDisposalEnergy, disposalEnergy));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getDisposalCarbon() {
		return disposalCarbon;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setDisposalCarbon(NullableQuantity newDisposalCarbon) {
		NullableQuantity oldDisposalCarbon = disposalCarbon;
		disposalCarbon = newDisposalCarbon;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, BuildingPhysicsPackage.WINDOW_TYPE__DISPOSAL_CARBON,
					oldDisposalCarbon, disposalCarbon));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getDisposalDescription() {
		return disposalDescription;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setDisposalDescription(String newDisposalDescription) {
		String oldDisposalDescription = disposalDescription;
		disposalDescription = newDisposalDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					BuildingPhysicsPackage.WINDOW_TYPE__DISPOSAL_DESCRIPTION, oldDisposalDescription,
					disposalDescription));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case BuildingPhysicsPackage.WINDOW_TYPE__WINDOW_TYPE_ID:
			return getWindowTypeId();
		case BuildingPhysicsPackage.WINDOW_TYPE__NAME:
			return getName();
		case BuildingPhysicsPackage.WINDOW_TYPE__UVALUE:
			return getUValue();
		case BuildingPhysicsPackage.WINDOW_TYPE__GVALUE:
			return getGValue();
		case BuildingPhysicsPackage.WINDOW_TYPE__GLAZING_NUMBER:
			return getGlazingNumber();
		case BuildingPhysicsPackage.WINDOW_TYPE__FRAME_RATIO:
			return getFrameRatio();
		case BuildingPhysicsPackage.WINDOW_TYPE__EMBODIED_ENERGY:
			return getEmbodiedEnergy();
		case BuildingPhysicsPackage.WINDOW_TYPE__EMBODIED_CARBON:
			return getEmbodiedCarbon();
		case BuildingPhysicsPackage.WINDOW_TYPE__CONSTRUCTION_DESCRIPTION:
			return getConstructionDescription();
		case BuildingPhysicsPackage.WINDOW_TYPE__DISPOSAL_ENERGY:
			return getDisposalEnergy();
		case BuildingPhysicsPackage.WINDOW_TYPE__DISPOSAL_CARBON:
			return getDisposalCarbon();
		case BuildingPhysicsPackage.WINDOW_TYPE__DISPOSAL_DESCRIPTION:
			return getDisposalDescription();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case BuildingPhysicsPackage.WINDOW_TYPE__WINDOW_TYPE_ID:
			setWindowTypeId((String) newValue);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__NAME:
			setName((String) newValue);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__UVALUE:
			setUValue((NullableQuantity) newValue);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__GVALUE:
			setGValue((Double) newValue);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__GLAZING_NUMBER:
			setGlazingNumber((Integer) newValue);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__FRAME_RATIO:
			setFrameRatio((Double) newValue);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__EMBODIED_ENERGY:
			setEmbodiedEnergy((NullableQuantity) newValue);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__EMBODIED_CARBON:
			setEmbodiedCarbon((NullableQuantity) newValue);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__CONSTRUCTION_DESCRIPTION:
			setConstructionDescription((String) newValue);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__DISPOSAL_ENERGY:
			setDisposalEnergy((NullableQuantity) newValue);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__DISPOSAL_CARBON:
			setDisposalCarbon((NullableQuantity) newValue);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__DISPOSAL_DESCRIPTION:
			setDisposalDescription((String) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case BuildingPhysicsPackage.WINDOW_TYPE__WINDOW_TYPE_ID:
			setWindowTypeId(WINDOW_TYPE_ID_EDEFAULT);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__NAME:
			setName(NAME_EDEFAULT);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__UVALUE:
			setUValue(UVALUE_EDEFAULT);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__GVALUE:
			setGValue(GVALUE_EDEFAULT);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__GLAZING_NUMBER:
			setGlazingNumber(GLAZING_NUMBER_EDEFAULT);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__FRAME_RATIO:
			setFrameRatio(FRAME_RATIO_EDEFAULT);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__EMBODIED_ENERGY:
			setEmbodiedEnergy(EMBODIED_ENERGY_EDEFAULT);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__EMBODIED_CARBON:
			setEmbodiedCarbon(EMBODIED_CARBON_EDEFAULT);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__CONSTRUCTION_DESCRIPTION:
			setConstructionDescription(CONSTRUCTION_DESCRIPTION_EDEFAULT);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__DISPOSAL_ENERGY:
			setDisposalEnergy(DISPOSAL_ENERGY_EDEFAULT);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__DISPOSAL_CARBON:
			setDisposalCarbon(DISPOSAL_CARBON_EDEFAULT);
			return;
		case BuildingPhysicsPackage.WINDOW_TYPE__DISPOSAL_DESCRIPTION:
			setDisposalDescription(DISPOSAL_DESCRIPTION_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case BuildingPhysicsPackage.WINDOW_TYPE__WINDOW_TYPE_ID:
			return WINDOW_TYPE_ID_EDEFAULT == null ? windowTypeId != null
					: !WINDOW_TYPE_ID_EDEFAULT.equals(windowTypeId);
		case BuildingPhysicsPackage.WINDOW_TYPE__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case BuildingPhysicsPackage.WINDOW_TYPE__UVALUE:
			return UVALUE_EDEFAULT == null ? uValue != null : !UVALUE_EDEFAULT.equals(uValue);
		case BuildingPhysicsPackage.WINDOW_TYPE__GVALUE:
			return gValue != GVALUE_EDEFAULT;
		case BuildingPhysicsPackage.WINDOW_TYPE__GLAZING_NUMBER:
			return glazingNumber != GLAZING_NUMBER_EDEFAULT;
		case BuildingPhysicsPackage.WINDOW_TYPE__FRAME_RATIO:
			return frameRatio != FRAME_RATIO_EDEFAULT;
		case BuildingPhysicsPackage.WINDOW_TYPE__EMBODIED_ENERGY:
			return EMBODIED_ENERGY_EDEFAULT == null ? embodiedEnergy != null
					: !EMBODIED_ENERGY_EDEFAULT.equals(embodiedEnergy);
		case BuildingPhysicsPackage.WINDOW_TYPE__EMBODIED_CARBON:
			return EMBODIED_CARBON_EDEFAULT == null ? embodiedCarbon != null
					: !EMBODIED_CARBON_EDEFAULT.equals(embodiedCarbon);
		case BuildingPhysicsPackage.WINDOW_TYPE__CONSTRUCTION_DESCRIPTION:
			return CONSTRUCTION_DESCRIPTION_EDEFAULT == null ? constructionDescription != null
					: !CONSTRUCTION_DESCRIPTION_EDEFAULT.equals(constructionDescription);
		case BuildingPhysicsPackage.WINDOW_TYPE__DISPOSAL_ENERGY:
			return DISPOSAL_ENERGY_EDEFAULT == null ? disposalEnergy != null
					: !DISPOSAL_ENERGY_EDEFAULT.equals(disposalEnergy);
		case BuildingPhysicsPackage.WINDOW_TYPE__DISPOSAL_CARBON:
			return DISPOSAL_CARBON_EDEFAULT == null ? disposalCarbon != null
					: !DISPOSAL_CARBON_EDEFAULT.equals(disposalCarbon);
		case BuildingPhysicsPackage.WINDOW_TYPE__DISPOSAL_DESCRIPTION:
			return DISPOSAL_DESCRIPTION_EDEFAULT == null ? disposalDescription != null
					: !DISPOSAL_DESCRIPTION_EDEFAULT.equals(disposalDescription);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (windowTypeId: ");
		result.append(windowTypeId);
		result.append(", name: ");
		result.append(name);
		result.append(", uValue: ");
		result.append(uValue);
		result.append(", gValue: ");
		result.append(gValue);
		result.append(", glazingNumber: ");
		result.append(glazingNumber);
		result.append(", frameRatio: ");
		result.append(frameRatio);
		result.append(", embodiedEnergy: ");
		result.append(embodiedEnergy);
		result.append(", embodiedCarbon: ");
		result.append(embodiedCarbon);
		result.append(", constructionDescription: ");
		result.append(constructionDescription);
		result.append(", disposalEnergy: ");
		result.append(disposalEnergy);
		result.append(", disposalCarbon: ");
		result.append(disposalCarbon);
		result.append(", disposalDescription: ");
		result.append(disposalDescription);
		result.append(')');
		return result.toString();
	}

} //WindowTypeImpl
